﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XamDataGrid_hierLayout
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            this.DataContext = GetData();
            InitializeComponent();
        }

        private ObservableCollection<Product> GetData()
        {
            ObservableCollection<Product> products = new ObservableCollection<Product>();

            for (int i = 1; i <= 10; ++i)
            {
                products.Add(new Product(i, "Product " + i, new ObservableCollection<ProductDetails>() {
                                                                                                         new ProductDetails(i * 3, i * 2.5, i * 2)
                                                                                                       }));
            }

            return products;
        }
    }

    public class Product
    {
        public int ID { get; set; }
        public string Name { get; set; }
        public ObservableCollection<ProductDetails> Details { get; set; }
        public NestedData NestedProperty { get; set; }

        public Product(int id, string name, ObservableCollection<ProductDetails> details)
        {
            this.ID = id;
            this.Name = name;
            this.Details = details;
            this.NestedProperty = new NestedData(details);
        }
    }

    public class NestedData
    {
        //Want to visualize this data
        public ObservableCollection<WatchListData> WatchList { get; set; }

        public NestedData(ObservableCollection<ProductDetails> details)
        {
            WatchList = new ObservableCollection<WatchListData>();

            foreach (var item in details)
            {
                WatchListData newData = new WatchListData(item.Weight, item.Price, item.Quantity);
                WatchList.Add(newData);
            }
        }
    }

    public class WatchListData
    {
        public double Weight { get; set; }
        public double Price { get; set; }
        public int Quantity { get; set; }

        public WatchListData(double weight, double price, int quantity)
        {
            this.Weight = weight;
            this.Price = price;
            this.Quantity = quantity;
        }
    }

    public class ProductDetails
    {
        public double Weight { get; set; }
        public double Price { get; set; }
        public int Quantity { get; set; }

        public ProductDetails(double weight, double price, int quantity)
        {
            this.Weight = weight;
            this.Price = price;
            this.Quantity = quantity;
        }
    }
}